Wt: Wt::WMenuItem Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WMenuItem Class Reference

A single item in a menu. More...

`#include <WMenuItem.h>`

Inheritance diagram for Wt::WMenuItem:
[legend]

## Public Member Functions
| WMenuItem (const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| Creates a new item with given label.
void | setText (const WString &text)
| Sets the text for this item.
WString | text () const
| Returns the text for this item.
void | setIcon (const std::string &path)
| Sets the item icon path.
std::string | icon () const
| Returns the item icon path.
void | setCheckable (bool checkable)
| Sets if the item is checkable.
bool | isCheckable () const
| Returns whether the item is checkable.
virtual void | setPathComponent (const std::string &path)
| Sets the path component for this item.
virtual std::string | pathComponent () const
| Returns the path component for this item.
virtual void | setInternalPathEnabled (bool enabled)
| Configures internal path support for the item.
virtual bool | internalPathEnabled () const
| Returns whether an item participates in internal paths.
void | setLink (const WLink &link)
| Sets the associated link.
WLink | link () const
| Returns the associated link.
void | setMenu (std::unique_ptr< WMenu > menu)
| Sets a sub menu.
WMenu * | menu () const
| Returns the submenu.
void | setChecked (bool checked)
| Sets the checked state.
bool | isChecked () const
| Returns the checked state.
void | setSelectable (bool selectable) override
| Sets whether the menu item can be selected.
bool | isSelectable () const
| Returns whether the menu item can be selected.
void | setData (void *data)
| Sets associated additional data with the item.
void * | data () const
| Returns additional data of the item.
WCheckBox * | checkBox () const
| Returns the checkbox for a checkable item.
void | setCloseable (bool closeable)
| Make it possible to close this item interactively or by close().
bool | isCloseable () const
| Returns whether the item is closeable.
void | close ()
| Closes this item.
WMenu * | parentMenu () const
| Returns the menu that contains this item.
void | setContents (std::unique_ptr< WWidget > contents, ContentLoading policy=ContentLoading::Lazy)
| Sets the contents widget for this item.
WWidget * | contents () const
| Returns the contents widget for this item.
std::unique_ptr< WWidget > | removeContents ()
| Removes the contents widget from this item.
void | select ()
| Selects this item.
Signal< WMenuItem * > & | triggered ()
| Signal emitted when an item is activated.
bool | isSeparator () const
| Returns whether this item is a separator.
bool | isSectionHeader () const
| Returns whether this item is a section header.
WAnchor * | anchor () const
| Returns the anchor of this menu item.
virtual void | renderSelected (bool selected)
| Renders the item as selected or unselected.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
Public Member Functions inherited from Wt::WContainerWidget
| WContainerWidget ()
| Creates a container.
| ~WContainerWidget ()
| Destructor.
void | setLayout (std::unique_ptr< WLayout > layout)
| Sets a layout manager for the container.
template<typename Layout >
Layout * | setLayout (std::unique_ptr< Layout > layout)
| Sets a layout manager for the container, returning a raw pointer.
WLayout * | layout () const
| Returns the layout manager that was set for the container.
virtual void | addWidget (std::unique_ptr< WWidget > widget)
| Adds a child widget to this container.
template<typename Widget >
Widget * | addWidget (std::unique_ptr< Widget > widget)
| Adds a child widget to this container, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | addNew (Args &&...args)
| Creates a widget and adds it, returning a reference to it.
virtual void | insertBefore (std::unique_ptr< WWidget > widget, WWidget *before)
| Inserts a child widget in this container, before another widget.
template<typename Widget >
Widget * | insertBefore (std::unique_ptr< Widget > widget, WWidget *before)
| Inserts a child widget to this container, before another widget, returning a raw pointer.
virtual void | insertWidget (int index, std::unique_ptr< WWidget > widget)
| Inserts a child widget in this container at given index.
template<typename Widget >
Widget * | insertWidget (int index, std::unique_ptr< Widget > widget)
| Inserts a child widget to this container at given index, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | insertNew (int index, Args &&...args)
| Creates a widget and inserts it, returning a reference to it.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget from this container.
virtual void | clear ()
| Removes all widgets.
virtual int | indexOf (WWidget *widget) const
| Returns the index of a widget.
virtual WWidget * | widget (int index) const
| Returns the widget at index
virtual int | count () const
| Returns the number of widgets in this container.
void | setContentAlignment (WFlags< AlignmentFlag > contentAlignment)
| Specifies how child widgets must be aligned within the container.
void | setPadding (const WLength &padding, WFlags< Side > sides=AllSides)
| Sets padding inside the widget.
WLength | padding (Side side) const
| Returns the padding set for the widget.
WFlags< AlignmentFlag > | contentAlignment () const
| Returns the alignment of children.
void | setOverflow (Overflow overflow, WFlags< Orientation > orientation=(Orientation::Horizontal|Orientation::Vertical))
| Sets how overflow of contained children must be handled.
void | setList (bool list, bool ordered=false)
| Renders the container as an HTML list.
bool | isList () const
| Returns if this container is rendered as a List.
bool | isUnorderedList () const
| Returns if this container is rendered as an Unordered List.
bool | isOrderedList () const
| Returns if this container is rendered as an Ordered List.
EventSignal< WScrollEvent > & | scrolled ()
| Event signal emitted when scrolling in the widget.
int | scrollTop () const
| return the number of pixels the container is scrolled horizontally
int | scrollLeft () const
| return the number of pixels the container is scrolled vertically
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WContainerWidget
Protected Member Functions inherited from Wt::WInteractWidget
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A single item in a menu.

Since Wt 3.3.0, this item is now a proper widget, which renders a single item in a menu.

An optional contents item can be associated with a menu item, which is inserted and shown in the widget stack of the menu to which this menu item belongs.

### CSS

A menu item renders as a >li&;lt with additional markup/style classes provided by the theme. Unless you use the bootstrap theme, you will need to provide appropriate CSS.

## Constructor & Destructor Documentation

## ◆ WMenuItem()

Wt::WMenuItem::WMenuItem | ( | const WString & | label,
|  | std::unique_ptr< WWidget > | contents = nullptr,
|  | ContentLoading | policy = ContentLoading::Lazy )

Creates a new item with given label.

The optional contents is a widget that will be shown in the WMenu contents stack when the item is selected. For this widget, a load `policy` specifies whether the contents widgets is transmitted only when it the item is activated for the first time (LazyLoading) or transmitted prior to first rendering.

If the menu supports internal path navigation, then a default pathComponent() will be derived from the `label`, and can be customized using setPathComponent().

## Member Function Documentation

## ◆ anchor()

WAnchor * Wt::WMenuItem::anchor | ( |  | ) | const

Returns the anchor of this menu item.

Can be used to add widgets to the menu.

## ◆ checkBox()

WCheckBox * Wt::WMenuItem::checkBox | ( |  | ) | const

Returns the checkbox for a checkable item.

See also
  setCheckable()

## ◆ close()

void Wt::WMenuItem::close | ( |  | ) |

Closes this item.

Hides the item widget and emits WMenu::itemClosed() signal. Only closeable items can be closed.

See also
  setCloseable(), hide()

## ◆ contents()

WWidget * Wt::WMenuItem::contents | ( |  | ) | const

Returns the contents widget for this item.

See also
  setContents()

## ◆ data()

void * Wt::WMenuItem::data | ( |  | ) | const

Returns additional data of the item.

See also
  setData()

## ◆ enableAjax()

virtual void Wt::WMenuItem::enableAjax | ( |  | ) |
| overridevirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WWebWidget.

## ◆ icon()

std::string Wt::WMenuItem::icon | ( |  | ) | const

Returns the item icon path.

See also
  setIcon()

## ◆ internalPathEnabled()

virtual bool Wt::WMenuItem::internalPathEnabled | ( |  | ) | const
| virtual

Returns whether an item participates in internal paths.

See also
  setInternalPathEnabled()

## ◆ isCheckable()

bool Wt::WMenuItem::isCheckable | ( |  | ) | const

Returns whether the item is checkable.

See also
  setCheckable()

## ◆ isChecked()

bool Wt::WMenuItem::isChecked | ( |  | ) | const

Returns the checked state.

This is only used when isCheckable() == `true`.

See also
  setChecked(bool), isCheckable()

## ◆ isCloseable()

bool Wt::WMenuItem::isCloseable | ( |  | ) | const

Returns whether the item is closeable.

See also
  setCloseable()

## ◆ isSectionHeader()

bool Wt::WMenuItem::isSectionHeader | ( |  | ) | const

Returns whether this item is a section header.

See also
  WMenu::addSectionHeader()

## ◆ isSelectable()

bool Wt::WMenuItem::isSelectable | ( |  | ) | const

Returns whether the menu item can be selected.

See also
  setSelectable()

## ◆ isSeparator()

bool Wt::WMenuItem::isSeparator | ( |  | ) | const

Returns whether this item is a separator.

See also
  WMenu::addSeparator()

## ◆ link()

WLink Wt::WMenuItem::link | ( |  | ) | const

Returns the associated link.

See also
  setLink()

## ◆ menu()

WMenu * Wt::WMenuItem::menu | ( |  | ) | const

Returns the submenu.

See also
  setMenu()

## ◆ pathComponent()

virtual std::string Wt::WMenuItem::pathComponent | ( |  | ) | const
| virtual

Returns the path component for this item.

You may want to reimplement this to customize the path component set by the item in the application internal path.

See also
  setPathComponent()

Note
  the `path` component is CharEncoding::UTF8 encoded (we may fix the API to use WString in the future).

## ◆ render()

virtual void Wt::WMenuItem::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WWebWidget.

## ◆ renderSelected()

virtual void Wt::WMenuItem::renderSelected | ( | bool | selected | ) |
| virtual

Renders the item as selected or unselected.

The default implementation sets the styleclass for itemWidget() to 'item' for an unselected not closeable, 'itemselected' for selected not closeable, 'citem' for an unselected closeable and 'citemselected' for selected closeable item.

Note that this method is called from within a stateless slot implementation, and thus should be stateless as well.

## ◆ select()

void Wt::WMenuItem::select | ( |  | ) |

Selects this item.

If the item was previously closed it will be shown.

See also
  close()

## ◆ setCheckable()

void Wt::WMenuItem::setCheckable | ( | bool | checkable | ) |

Sets if the item is checkable.

When an item is checkable, a checkbox is displayed to the left of the item text (instead of an icon).

See also
  setChecked(), isChecked()

## ◆ setChecked()

void Wt::WMenuItem::setChecked | ( | bool | checked | ) |

Sets the checked state.

This is only used when isCheckable() == `true`.

See also
  setCheckable(bool), isCheckable()

## ◆ setCloseable()

void Wt::WMenuItem::setCloseable | ( | bool | closeable | ) |

Make it possible to close this item interactively or by close().

See also
  close(), isCloseable()

## ◆ setContents()

void Wt::WMenuItem::setContents | ( | std::unique_ptr< WWidget > | contents,
|  | ContentLoading | policy = ContentLoading::Lazy )

Sets the contents widget for this item.

The contents is a widget that will be shown in the WMenu contents stack when the item is selected. For this widget, the load `policy` specifies whether the contents widgets is transmitted only when it the item is activated for the first time (LazyLoading) or transmitted prior to first rendering.

## ◆ setData()

void Wt::WMenuItem::setData | ( | void * | data | ) |

Sets associated additional data with the item.

You can use this to associate model information with a menu item.

## ◆ setDisabled()

virtual void Wt::WMenuItem::setDisabled | ( | bool | disabled | ) |
| overridevirtual

Sets whether the widget is disabled.

Enables or disables the widget (including all its descendant widgets). setDisabled(false) will enable this widget and all descendant widgets that are not disabled. A widget is only enabled if it and all its ancestors in the widget tree are disabled.

Typically, a disabled form widget will not allow changing the value, and disabled widgets will not react to mouse click events.

Note
  enable() and disable() are considered to be stateless slots by default. If you override setDisabled() and need to modify server state whenever it is called, you'll need to call WObject::isNotStateless().

See also
  disable(), enable()

Reimplemented from Wt::WWebWidget.

## ◆ setHidden()

virtual void Wt::WMenuItem::setHidden | ( | bool | hidden,
|  | const WAnimation & | animation = WAnimation() )
| overridevirtual

Hides or shows the widget.

Hides or show the widget (including all its descendant widgets). When setting `hidden` = `false`, this widget and all descendant widgets that are not hidden will be shown. A widget is only visible if it and all its ancestors in the widget tree are visible, which may be checked using isVisible().

Note
  hide() and show() are considered to be stateless slots by default. If you override setHidden() and need to modify server state whenever it is called, you'll need to call WObject::isNotStateless().

Reimplemented from Wt::WWebWidget.

## ◆ setIcon()

void Wt::WMenuItem::setIcon | ( | const std::string & | path | ) |

Sets the item icon path.

The icon should have a width of 16 pixels.

See also
  setText()

## ◆ setInternalPathEnabled()

virtual void Wt::WMenuItem::setInternalPathEnabled | ( | bool | enabled | ) |
| virtual

Configures internal path support for the item.

This configures whether the item supports internal paths (in a menu which supports internal paths).

The default value is `true` for all items but section headers and separators.

See also
  WMenu::setInternalPathEnabled()

## ◆ setLink()

void Wt::WMenuItem::setLink | ( | const WLink & | link | ) |

Sets the associated link.

See also
  Link()

## ◆ setMenu()

void Wt::WMenuItem::setMenu | ( | std::unique_ptr< WMenu > | menu | ) |

Sets a sub menu.

In most cases, the sub menu would use the same contents stack as the parent menu.

Note that adding a submenu makes this item not selectable by default.

Note
  If the parent menu is a WPopupMenu, the submenu should also be a WPopupMenu.

See also
  setSelectable()

## ◆ setPathComponent()

virtual void Wt::WMenuItem::setPathComponent | ( | const std::string & | path | ) |
| virtual

Sets the path component for this item.

The path component is used by the menu item in the application internal path (see WApplication::setInternalPath()), when internal paths are enabled (see WMenu::setInternalPathEnabled()) for the menu.

You may specify an empty `path` to let a menu item be the "default" menu option.

For example, if WMenu::internalBasePath() is `"/examples/"` and pathComponent() for is `"charts/"`, then the internal path for the item will be `"/examples/charts/"`.

By default, the path is automatically derived from text(). If a literal text is used, the path is based on the text itself, otherwise on the key. It is converted to lower case, and replacing whitespace and special characters with '_'.

See also
  setText(), WMenu::setInternalPathEnabled()

Note
  the `path` should be CharEncoding::UTF8 encoded (we may fix the API to use WString in the future).

## ◆ setSelectable()

void Wt::WMenuItem::setSelectable | ( | bool | selectable | ) |
| overridevirtual

Sets whether the menu item can be selected.

Only a menu item that can be selected can be the result of a popup menu selection.

The default value is `true` for a normal menu item, and `false` for a menu item that has a popup submenu.

An item that is selectable but is disabled can still not be selected.

Reimplemented from Wt::WWebWidget.

## ◆ setText()

void Wt::WMenuItem::setText | ( | const WString & | text | ) |

Sets the text for this item.

Unless a custom path component was defined, the pathComponent() is also updated based on the new text.

The item widget is updated using updateItemWidget().

See also
  setPathComponent();

## ◆ text()

WString Wt::WMenuItem::text | ( |  | ) | const

Returns the text for this item.

See also
  setText();

## ◆ triggered()

Signal< WMenuItem * > & Wt::WMenuItem::triggered | ( |  | ) |

Signal emitted when an item is activated.

Returns this item as argument.

See also
  WMenu::triggered()